'use strict';

/*************************************************************************************************/
/* ************************************** CODE PRINCIPAL *************************************** */
/*************************************************************************************************/

/*
 * Installation d'un gestionnaire d'évènement déclenché quand l'arbre DOM sera totalement construit
 * par le navigateur.
 *
 * Lorsque l'on donne en argument une fonction à jQuery, elle est utilisée comme gestionnaire
 * d'évènements pour l'évènement JavaScript natif DOMContentLoaded.
 */
$(function()
{
    $('#run').on('click', onClickExecute);












    /////////// Exemples chargement

    // générer un fichier lourd
    // https://www.json-generator.com/

    // Exemple sans setup
    // http://www.dave-bond.com/blog/2010/01/JQuery-ajax-progress-HMTL5/
	$.ajax({
	  xhr: function()
	  {
	    var xhr = new window.XMLHttpRequest();
	    //Download progress
	    xhr.addEventListener("progress", function(evt){
	      if (evt.lengthComputable) {
	        
	        // Calcul du % de chargement
	        var percentComplete = evt.loaded / evt.total; // exemple : 0.165462

	        // Formatage
	        percentComplete *= 100; // exemple 16.5462

	        percentComplete = parseInt(percentComplete, 10) //  exemple 16

	        percentComplete += "%"; // exemple 16%

	        console.log("chargement : " + percentComplete);
	      }
	    }, false);
	    return xhr;
	  },
	  type: 'POST',
	  url: "generated.json",
	  data: {},
	  success: function(data){
	    //Do something success-ish
	  }
	});















    // Définition des valeurs par défaut pour les prochaines utilisations
    // https://gist.github.com/RobinHerbots/5271016
    var originalXhr = $.ajaxSettings.xhr;
    $.ajaxSetup({
        progress: $.noop, // fonction vide
        xhr: function() {
            var req = originalXhr(), that = this;
            if (req) {
                if (typeof req.addEventListener == "function") {
                    req.addEventListener("progress", function(evt) {
                        that.progress(evt);
                    },false);
                }
            }
            return req;
        }
    });

    // usage:
	// note, if testing locally, size of file needs to be large enough
	// to allow time for events to fire

	$.ajax({
	    url: "generated.json",
	    type: "GET",
	    dataType: "json",
	    complete: function() { console.log("Completed."); },
	    progress: function(evt) {
	        if (evt.lengthComputable) {
	            
	            // Calcul du % de chargement
		        var percentComplete = evt.loaded / evt.total; // exemple : 0.165462

		        // Formatage
		        percentComplete *= 100; // exemple 16.5462

		        percentComplete = parseInt(percentComplete, 10) //  exemple 16

		        percentComplete += "%"; // exemple 16%

		        console.log("chargement : " + percentComplete);

	        }
	        else {
	            console.log("Length not computable.");
	        }
	    }

	});





	
});


